#!/usr/bin/env python

import sys
from pyraf import iraf

# configuration
iraf.stdimage = 'imt4096'
ccd_arrange = 'ccd_arrange.lis'

# input file
infile=sys.argv[1] # SUPAXXXXXXX

# -- main part start --

# -- read CCD arragement info

frame_detid = {} # creating a new empty dictionary

for line in open(ccd_arrange):
    line=line.strip().split()
    if line[0].startswith('#') == False:
        print line 
        frame=int(line[0]) # converting to integer
        detid=int(line[1]) 
        frame_detid[frame]=detid # adding a new pair to the dictionary

print 'resultant dictionary: ', frame_detid

# -- read FITS name & display 10 FITS
for frame in (1, 2, 3, 4, 5, 6, 7, 8, 9, 10):  # for 1,2,..,9,10 (10 elements)
# the below is the same meaning
# for frame in range(1,11):  
# this part can also be rewritten as
#
# for frame, detid in frame_detid.iteritems():
#
    detid=frame_detid[frame]
    fits=infile + str(detid) + '.fits'

    print 'detid:frame - ', detid ,frame
    print 'fitsname: ', fits

    # this is the PyRAF task
    iraf.display(fits, frame, fill=1, zscale=1, zrange=0, z1=None, z2=None)

    print 'displaying - %s in frame %d' % (fits, frame)
    
#for detid,frame in detid_frame: can i do this?


print 'done.'
