#!/usr/bin/env python

import sys
from pyraf import iraf

# configuration
iraf.stdimage = 'imt4096'
ccd_arrange = 'ccd_arrange.lis'

# input file
fitslist=sys.argv[1] # a list of file names of 10 FITS.

# -- main part start --

# -- read CCD arragement info

frame_fits = {} # creating a new empty dictionary

for line in open(ccd_arrange):
    line=line.strip().split()
    if line[0].startswith('#') == False:
        print line 
        frame=int(line[0]) # converting to integer
        detid=int(line[1]) 

        # to search for fits name for this detid
        for fits in open(fitslist):
            fits=fits.strip()
            suffix=str(detid)+'.fits'
            if fits.endswith(suffix) == True:
                frame_fits[frame]=fits # adding a new pair to the dictionary
                break                  # break out of for this loop


print 'resultant dictionary: ', frame_fits

# -- read FITS name & display 10 FITS
for frame, fits in frame_fits.iteritems():

    print 'frame %d - fits %s' % (frame, fits)

    # this is the PyRAF task
    iraf.display(fits, frame, fill=1, zscale=1, zrange=0, z1=None, z2=None)

    print 'displaying - %s in frame %d' % (fits, frame)
    
#for detid,frame in detid_frame: can i do this?


print 'done.'
