#!/usr/bin/env python

"""
usage: ffield2.py  osslist  flat0.fits
"""

import sys
from pyraf import iraf

def check_filter01(infits, flat):
    filter_infits=iraf.hselect(infits,'filter01','yes', Stdout=1)
    filter_flat=iraf.hselect(flat,'filter01','yes', Stdout=1)

    ### either task can be used. 
    ### output from hedit - ['oss_SUPA00207540.fits,FILTER01 = W-C-RC']
    #ret=iraf.hedit(images=infits, fields='filter01', value='.', Stdout=1)
    #ret=ret[0].split()
    #filter_infits=ret[2]
    #ret=iraf.hedit(images=flat, fields='filter01', value='.', Stdout=1)
    #ret=ret[0].split()
    #filter_flat=ret[2]

    if filter_infits !=filter_flat:
        print 'ALERT: different filters for %s and %s.' % (infits, flat)
    else:
        print 'OK: same filters for %s and %s.' % (infits, flat)


def ffield(infits, flat, outfits): 

    check_filter01(infits, flat)

    # -- divide the input image by flat image

    print 'executing %s / %s = %s' % (infits, flat, outfits)
    iraf.imarith(infits, '/', flat, outfits)

    print 'ffield() - done.'


def main():
    if len(sys.argv) != 3:
        print __doc__
        sys.exit(0)

    osslist=sys.argv[1]
    flat=sys.argv[2]

    for infits in open(osslist):
        infits=infits.strip()
        outfits='flt_'+infits

        ffield(infits, flat, outfits)
    

# --- this is the main part ---
if __name__ == "__main__":
    main()
