#!/usr/bin/env python

import sys
from pyraf import iraf

def norm(oss_fitslist): # <-- definition of function

####    oss_fitslist=sys.argv[1]
    
    for infits in open(oss_fitslist):

        infits=infits.strip()
        outfits='nrm_'+infits

        # -- measure median of the sky background counts

        med=iraf.imstat(infits, fields='midpt', Stdout=1)
        med=float(med[1])
        print 'infits=%s: median=%f' % (infits, med)

        # -- divide the input image by the median  

        print 'executing %s / %f = %s' % (infits, med, outfits)
        iraf.imarith(infits, '/', med, outfits)


    print 'norm() - done.'


def comb(osslist, outflat):

    # -- 1. creating a list of nrm frames

####    osslist = sys.argv[1]  #  osslist is the same input file which is used in norm.py
####    outflat = sys.argv[2]  #  output flat file name given by the 2nd argument

    fitslist = []
    for fits in open(osslist):
        nrmfits='nrm_' + fits.strip()
        fitslist.append(nrmfits)      # add this nrm fits name to the fitslist
    fitslist = ','.join(fitslist)     # imcombine only accepts 'file1,file2,file3,...'

    print 'input fitslist: ', fitslist

    # -- 2. stack the fits files to a flat 

    print 'stacking - ', fitslist, ' into ', outflat

    iraf.imcombine(fitslist, combine='median', output=outflat)

    print 'comb() - done.'


# --- this is the main part ---
norm(oss_fitslist='oss.list')
comb(osslist='oss.list', outflat='flat0.fits')
