#!/usr/bin/env python

"""
usage: mkflat2pyfits.py  osslist  outflat.fits
"""

import sys
###from pyraf import iraf
import pyfits
import numpy

def norm_pyfits(osslist): # <-- definition of function

####    osslist=sys.argv[1]
 
    for infits in open(osslist):

        infits=infits.strip()
        outfits='nrm_'+infits

        # -- measure median of the sky background counts

        # To get pixdata & header info from HDU
        pixdata, hdr=pyfits.getdata(infits, header=True)
        nx=int(hdr['naxis1'])
        ny=int(hdr['naxis2'])
        print 'nx: ', nx
        print 'ny: ', ny

        #### med=iraf.imstat(infits, fields='midpt', Stdout=1)
        #### med=float(med[1])
        #### ====>
        med=numpy.median(pixdata)     # calc median

        print 'infits=%s: median=%f' % (infits, med)

        # -- divide the input image by the median  

        print 'executing %s / %f = %s' % (infits, med, outfits)
        #### iraf.imarith(infits, '/', med, outfits)
        #### ====> 
        pixdata = pixdata / med  # <-- Pythonic way
        pyfits.writeto(outfits, pixdata, hdr) # writing out

    print 'norm() - done.'


def comb_pyfits(osslist, outflat):

    # -- 1. creating a list of nrm frames

    fits_list = []  # normal python list
    pixdata_array = [] # array of pixdata of input frames

    for fits in open(osslist):
        nrmfits='nrm_' + fits.strip()
        fits_list.append(nrmfits) 

        # To get pixdata & header info from HDU
        pixdata, hdr = pyfits.getdata(nrmfits, header=True) 

        # add pixdata of another input frame to the array 
        pixdata_array.append(pixdata) 

    print 'input fits_list: ', fits_list

    # -- 2. stack the fits files to a flat 

    print 'stacking - ', fits_list, ' into ', outflat

    # combining pixdata arrays by taking median

    ####iraf.imcombine(fitslist, combine='median', output=outflat)
    #### ===>
    pixdata_med = numpy.median(pixdata_array, axis=0) # numpy function
    print pixdata_med
    pyfits.writeto(outflat, pixdata_med, hdr) # writing out
                                              # hdr is from the last frame
    print 'comb() - done.'


def main():
    if len(sys.argv) != 3:
        print __doc__
        sys.exit(0)

    osslist=sys.argv[1]
    outflat=sys.argv[2]
    norm_pyfits(osslist)
    comb_pyfits(osslist, outflat)
    

# --- this is the main part ---
if __name__ == "__main__":
    main()
