#!/usr/bin/env python

"""
usage: mkflat3.py  osslist  outflat.fits
"""

import sys
from pyraf import iraf

def norm(osslist): # <-- definition of function

####    osslist=sys.argv[1]
 
    for infits in open(osslist):

        infits=infits.strip()
        outfits='nrm_'+infits

        # -- measure median of the sky background counts

        med=iraf.imstat(infits, fields='midpt', Stdout=1)
        med=float(med[1])
        print 'infits=%s: median=%f' % (infits, med)

        # -- divide the input image by the median  

        print 'executing %s / %f = %s' % (infits, med, outfits)
        iraf.imarith(infits, '/', med, outfits)

    print 'norm() - done.'


def comb(osslist, outflat, display=False):

    # -- 1. creating a list of nrm frames

####    osslist = sys.argv[1]  #  osslist is the same input file which is used in norm.py
####    outflat = sys.argv[2]  #  output flat file name given by the 2nd argument

    fitslist = []
    for fits in open(osslist):
        nrmfits='nrm_' + fits.strip()
        fitslist.append(nrmfits)      # add this nrm fits name to the fitslist
    fitslist = ','.join(fitslist)     # imcombine only accepts 'file1,file2,file3,...'

    print 'input fitslist: ', fitslist

    # -- 2. stack the fits files to a flat 

    print 'stacking - ', fitslist, ' into ', outflat

    iraf.imcombine(fitslist, combine='median', output=outflat)

    if display==True:
        ds9(outflat, 1)

    print 'comb() - done.'


def ds9(fits, frame=1):
    iraf.display(fits, frame, zscale=1, zrange=0, fill=1)
                 

def main():
    if len(sys.argv) != 3:
        print __doc__
        sys.exit(0)

    osslist=sys.argv[1]
    outflat=sys.argv[2]

    norm(osslist)
    comb(osslist, outflat, display=True)
    

# --- this is the main part ---
if __name__ == "__main__":
    main()
