#!/usr/bin/env python

"""
 usage: ./norm2ext.py oss.list median 1000 1200 2000 2400
"""
import sys
from pyraf import iraf

fitslist=sys.argv[1]
option=sys.argv[2]   # e.g., median, mean, med_clip, mean_clip
xmin=sys.argv[3]
xmax=sys.argv[4]
ymin=sys.argv[5]
ymax=sys.argv[6]

if option == 'median':
    fields = 'midpt'
    nclip = None
    print 'algorithm: median, no clip'
elif option == 'mean':
    fields = 'mean'
    nclip = None
    print 'algorithm: mean, no clip'
elif option == 'median_clip':
    fields = 'midpt'
    nclip = 3.0
    print 'algorithm: median, 3-sgm clip'
elif option == 'mean_clip':
    fields = 'mean'
    nclip = 3.0
    print 'algorithm: mean, 3-sgm clip'
else:
    fields = 'midpt'
    nclip = None
    print 'algorithm: mean, no clip'


region='['+xmin+':'+xmax+','+ymin+':'+ymax+']'
#print 'xy region %s is to be measured.' % region

for infits in open(fitslist):

    infits=infits.strip()
    outfits='nrm_'+infits

    # -- measure median of the sky background counts

    # med=iraf.imstat(infits, fields='midpt', Stdout=1)
    med=iraf.imstat(infits+region, fields=fields, nclip=nclip, Stdout=1)
    med=float(med[1])
    print 'infits=%s%s: median=%f' % (infits, region, med)

    # -- divide the input image by the median  

    print 'executing %s / %f = %s' % (infits, med, outfits)
    iraf.imarith(infits, '/', med, outfits)

print 'done.'
